
/*
 * Draw an axis aligned cube whose bottom lower left corner is  m and top
 * upper right corner is M.
 */
void
drawCube(const Vec& m,const Vec& M)
{
  const Vec corners[8] =
    {
      Vec(m[0],m[1],m[2]),
      Vec(M[0],m[1],m[2]),
      Vec(m[0],M[1],m[2]),
      Vec(M[0],M[1],m[2]),
      Vec(m[0],m[1],M[2]),
      Vec(M[0],m[1],M[2]),
      Vec(m[0],M[1],M[2]),
      Vec(M[0],M[1],M[2])
    };
  static const unsigned short faceCorners[6][4] =	
    {
      { 0,4,6,2 },
      { 5,1,3,7 },
      { 0,1,5,4 },
      { 3,2,6,7 },
      { 0,2,3,1 },
      { 6,4,5,7 }
    };  
  glBegin(GL_QUADS);
  for (unsigned short f=0;f<6;++f)
  {
    const unsigned short* face = faceCorners[f];
    glVertex3fv(corners[face[0]]);
    glVertex3fv(corners[face[1]]);
    glVertex3fv(corners[face[2]]);
    glVertex3fv(corners[face[3]]);
  }
  glEnd();
}
void
display(void)
{
  // Draw the grid
  if (drawGrid)
  {
    glLineWidth(1.0f);
    glColor3f(1.0f,1.0f,0.0f);
    glDisable(GL_LIGHTING);
    glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);
    Vec o = bbox.min();
    for (unsigned int i=0;i<nbI;++i)
    {
      for (unsigned int j=0;j<nbJ;++j)
      {
	for (unsigned int k=0;k<nbK;++k)
	{
	  drawCube(o+Vec(i*size,j*size,k*size),
		   o+Vec((i+1)*size,(j+1)*size,(k+1)*size));
	}
      }
    }
  }
}
